	     //Sazdavane na klas krasivo komplexno chislo
#include <iostream.h>
#include <string.h>
#include <conio.h>

class complex
{
 float re,im;
 char *name;
public:
 complex(float a,float b,char *p)
  {
   re=a;im=b;
   name=new char[strlen(p)+1];
   strcpy(name,p);
  }
 complex()
  {
   re=0.0;im=0.0;
   name=new char[strlen("NO")+1];
   strcpy(name,"NO");
  }
 complex(const complex &ob)
  {
   re=ob.re;im=ob.im;
   name=new char[strlen(ob.name)+1];
   strcpy(name,ob.name);
  }
 ~complex()
  {
   delete[]name;
  }
 complex operator+(complex ob)
  {
   complex temp;
   temp.re=re+ob.re;temp.im=im+ob.im;
   temp.name=new char[strlen(name)+strlen(ob.name)+2];
   strcpy(temp.name,name);
   strcat(temp.name,"+");
   strcat(temp.name,ob.name);
   return temp;
  }
 complex operator-(complex ob)
  {
   complex temp;
   temp.re=re-ob.re;temp.im=im-ob.im;
   temp.name=new char[strlen(name)+strlen(ob.name)+2];
   strcpy(temp.name,name);
   strcat(temp.name,"-");
   strcat(temp.name,ob.name);
   return temp;
  }
 complex operator*(complex ob)
  {
   complex temp;
   temp.re=re*ob.re-im*ob.im;
   temp.im=im*ob.re+re*ob.im;
   temp.name=new char[strlen(name)+strlen(ob.name)+2];
   strcpy(temp.name,name);
   strcat(temp.name,"*");
   strcat(temp.name,ob.name);
   return temp;
  }
 complex operator/(complex ob)
  {
   complex temp;
   temp.re=(re*ob.re+im*ob.im)/(ob.re*ob.re+ob.im*ob.im);
   temp.re=(im*ob.re-re*ob.im)/(ob.re*ob.re+ob.im*ob.im);
   temp.name=new char[strlen(name)+strlen(ob.name)+2];
   strcpy(temp.name,name);
   strcat(temp.name,"/");
   strcat(temp.name,ob.name);
   return temp;
  }
 complex operator+(float i)
  {
   complex temp;
   temp.re=re+i;temp.im=im;
   temp.name=new char[strlen(name)+strlen("+float")+1];
   strcpy(temp.name,name);
   strcat(temp.name,"+float");
   return temp;
  }
 complex operator-(float i)
  {
   complex temp;
   temp.re=re-i;temp.im=im;
   temp.name=new char[strlen(name)+strlen("-float")+1];
   strcpy(temp.name,name);
   strcat(temp.name,"-float");
   return temp;
  }
 complex operator*(float i)
  {
   complex temp;
   temp.re=re*i;temp.im=im*i;
   temp.name=new char[strlen(name)+strlen("*float")+1];
   strcpy(temp.name,name);
   strcat(temp.name,"*float");
   return temp;
  }
 complex operator/(float i)
  {
   complex temp;
   temp.re=re/i;temp.im=im/i;
   temp.name=new char[strlen(name)+strlen("/float")+1];
   strcpy(temp.name,name);
   strcat(temp.name,"/float");
   return temp;
  }
 complex operator++()
  {
   re++;im++;
   return *this;
  }
 complex operator++(int)
  {
   complex temp=*this;
   re++;im++;
   return temp;
  }
 complex operator--()
  {
   re--;im--;
   return *this;
  }
 complex operator--(int)
  {
   complex temp=*this;
   re--;im--;
   return temp;
  }
 complex operator=(complex a)
  {
   if(&a!=this)
    {
     re=a.re;im=a.im;
     delete[]name;
     name=new char[strlen(a.name)+1];
     strcpy(name,a.name);
    }
   return *this;
  }
 friend complex operator+(float i,complex ob);
 friend complex operator-(float i,complex ob);
 friend complex operator*(float i,complex ob);
 friend complex operator/(float i,complex ob);
 friend ostream &operator<<(ostream &stream,complex &ob);
 friend istream &operator>>(istream &stream,complex &ob);
};
 complex operator+(float i,complex ob)
  {
   complex temp;
   temp.re=ob.re+i;temp.im=ob.im;
   temp.name=new char[strlen("float+")+strlen(ob.name)+1];
   strcpy(temp.name,"float+");
   strcat(temp.name,ob.name);
   return temp;
  }
 complex operator-(float i,complex ob)
  {
   complex temp;
   temp.re=i-ob.re;temp.im=ob.im;
   temp.name=new char[strlen("float-")+strlen(ob.name)+1];
   strcpy(temp.name,"float-");
   strcat(temp.name,ob.name);
   return temp;
  }
 complex operator*(float i,complex ob)
  {
   complex temp;
   temp.re=ob.re*i;temp.im=ob.im*i;
   temp.name=new char[strlen("float*")+strlen(ob.name)+1];
   strcpy(temp.name,"float*");
   strcat(temp.name,ob.name);
   return temp;
  }
 complex operator/(float i,complex ob)
  {
   complex temp;
   temp.re=(i*ob.re)/(ob.re*ob.re+ob.im*ob.im);
   temp.im=(-i*ob.im)/(ob.re*ob.re+ob.im*ob.im);
   temp.name=new char[strlen("float/")+strlen(ob.name)+1];
   strcpy(temp.name,"float/");
   strcat(temp.name,ob.name);
   return temp;
  }
 ostream &operator<<(ostream &stream,complex &ob)
  {
   cout<<"re="<<ob.re<<", im="<<ob.im<<", name:"<<ob.name<<'\n';
   return stream;
  }
 istream &operator>>(istream &stream,complex &ob)
  {
   cout<<"Enter re:";
   stream>>ob.re;
   cout<<"Enter im:";
   stream>>ob.im;
   cout<<"Enter name:";
   stream>>ob.name;
   return stream;
  }


void main()
{
  clrscr();
  complex A(1,2,"A");
  complex B(5,7,"B");
  complex C;
  cout<<A;cout<<B;
  cout<<A+B;cout<<B-A;
  cout<<B*A;cout<<B/A;
  cout<<B+4;cout<<B-4;
  cout<<4+A;cout<<4-A;
  cout<<4*A;cout<<4/A;
  cout<<'\n';
  getch();
  cout<<A;cout<<B;
  B=A++;
  cout<<"B=A++ : "<<A<<" - "<<B;
  B=A--;
  cout<<"B=A-- : "<<A<<" - "<<B;
  B=++A;
  cout<<"B=++A : "<<A<<" - "<<B;
  B=--A;
  cout<<"B=--A : "<<A<<" - "<<B;
  A=B;
  cout<<A;
  B=7+A/5-B/A;
  cout<<B;
  cout<<C;
  cin>>C;
  cout<<C;
  getch();
}